/* CD2MP3 0.90 (C) 1998 Samuel Audet <guardia@cam.org> */

#define INCL_PM
#define INCL_DOS
#define INCL_DOSERRORS
#include <os2.h>
#include <stdio.h>
#include <string.h>

#include "spawner.h"
#include "cd2mp3pm.h"

BOOL cd2wav(char cddrive, int track, char *newname, GRABBER *grabber,
            char *custom, HQUEUE que, HEV quesem, char *quename)
{
   char cmdline[1024];
   char wavdir[256];
   char oldname[256];
   char *backslash;

   backslash=strrchr(newname,'\\');
   if(!backslash)
      strcpy(wavdir,".");
   else
   {
      memset(wavdir,0,sizeof(wavdir));
      memcpy(wavdir,newname,backslash-newname);
   }

   strcpy(oldname,wavdir);
   strcat(oldname,"\\");
   sprintf(strchr(oldname,0),grabber->mangling,track);

   /* building the command line */
   strcpy(cmdline, grabber->before);
   strcat(cmdline, " ");

   if(!grabber->noDrive)
   {
      *(strchr(cmdline, 0)+2) = 0;
      *(strchr(cmdline, 0)+1) = ':';
      *strchr(cmdline, 0) = cddrive;
      strcat(cmdline, " ");
   }

   sprintf(strchr(cmdline,0),"%s%d ", grabber->input, track);

   if(grabber->acceptsOutput)
      sprintf(strchr(cmdline,0),"%s%s\\Track ", grabber->output, wavdir);

   strcat(cmdline,grabber->after);
   strcat(cmdline," ");
   strcat(cmdline,custom);


   switch(grabber->type)
   {
      case WIN32OS2:
         if(doWin32OS2(grabber->exe, cmdline, cmdline, FALSE, que, quesem, quename))
         {
            rename(oldname,newname);
            return TRUE;
         }
         else
            return FALSE;
      case VDM:
         if(doNormal(grabber->exe, cmdline, SSF_TYPE_WINDOWEDVDM, FALSE, que, quesem, quename))
         {
            rename(oldname,newname);
            return TRUE;
         }
         else
            return FALSE;
      case VIO:
         if(doNormal(grabber->exe, cmdline, SSF_TYPE_WINDOWABLEVIO, FALSE, que, quesem, quename))
         {
            rename(oldname,newname);
            return TRUE;
         }
         else
            return FALSE;
      default:
         return FALSE;
   }
}
