#define CD2MP3_STOP      100
#define CD2MP3_STOPPED   400

enum TYPE {VIO, VDM, WIN32OS2};

typedef struct
{
   char id[64];
   char exe[128];
   enum TYPE type;
   char input[32];
   char output[32];
   char lq[64];
   char hq[64];
   char before[64];
   char after[64];
   char bitrate[32];
   int  bitrateMath;
   BOOL bitratePerChannel;
   BOOL acceptsOutput;
} ENCODER;

typedef struct
{
   char id[64];
   char exe[128];
   enum TYPE type;
   char input[32];
   char output[32];
   char mangling[32];
   char before[64];
   char after[64];
   BOOL acceptsOutput;
   BOOL noDrive;
} GRABBER;
